<?php
/**
 * Contenido extension pack (mpContenidoX), consists of multiple classes to
 * provide more features for Plugins/Modules.
 *
 * @package     Plugin_mpContenidoX
 * @subpackage  Bootstrap
 * @author      Murat Purc <murat@purc.de>
 * @copyright   Copyright (c) 2008-2010 Murat Purc (http://www.purc.de)
 * @license     http://www.gnu.org/licenses/gpl-2.0.html - GNU General Public License, version 2
 * @version     $Id$
 */


defined('CON_FRAMEWORK') or die('Illegal call');


plugin_include('mpContenidoX', 'libs/ConMp/Plugin/Bootstrap/Abstract.php');


/**
 * Plugin Bootstrap class
 *
 * @package     Plugin_mpContenidoX
 * @subpackage  Bootstrap
 * @author      Murat Purc <murat@purc.de>
 */
class mpContenidoX_Bootstrap extends ConMp_Plugin_Bootstrap_Abstract
{
    /**
     * Self instance
     * @var  mpContenidoX_Bootstrap
     */
    private static $_instance;


    /**
     * Prevent public instantiation.
     */
    protected function __construct()
    {
        $className = explode('_', get_class($this));
        parent::__construct($className[0]);
    }


    /**
     * Disable cloning
     */
    private function __clone()
    {
    }


    /**
     * Returns self instance.
     *
     * @return  mpContenidoX_Bootstrap
     */
    public static function getInstance()
    {
        if (self::$_instance == null) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }


    /**
     * Define some constants.
     *
     * @retun void
     */
    protected function _initConstants()
    {
        define('PLUGIN_MPCONTENIDOX_PATH', str_replace("\\", "/", realpath(dirname(__FILE__) . '/..')) . '/');
    }


    /**
     * Includes some needed sources.
     *
     * @retun void
     */
    protected function _initIncludes()
    {
        // donut
    }


    /**
     * Loads the main configuration from configs folder (configs/config.php).
     *
     * @retun void
     */
    protected function _initConfiguration()
    {
        // donut
    }


    /**
     * Adds the autoloader.
     *
     * @retun void
     */
    protected function _initAutoload()
    {
        spl_autoload_register(array('mpContenidoX_Bootstrap', 'autoload'));
    }


    /**
     * Fills registry with common applicationwide needed objects.
     *
     * @retun void
     */
    protected function _initRegistry()
    {
    }


    /**
     * The autoload implementation of ConMp.
     *
     * @param  string  $className  The classname to load
     * @retun void
     */
    public static function autoload($className)
    {
        $file = '';
        if ($className == 'ConMp' || (strlen($className) > 6 && substr($className, 0, 6) == 'ConMp_')) {
            $file = PLUGIN_MPCONTENIDOX_PATH . 'libs/' . str_replace('_', '/', $className) . '.php';
        }

        if (empty($file)) {
            return;
        }

        if (is_file($file)) {
            require_once($file);
        } else {
            throw new Exception('mpContenidoX_Bootstrap::autoload(): Couldn\'t load class file ' . $className);
        }
    }

}
