<?php
/**
 * Contenido extension pack (ContenidoX), consists of multiple classes to
 * provide more features for Plugins/Modules.
 *
 * @package     Plugin_mpContenidoX
 * @subpackage  Frontend_PageCode
 * @author      Murat Purc <murat@purc.de>
 * @copyright   Copyright (c) 2008-2010 Murat Purc (http://www.purc.de)
 * @license     http://www.gnu.org/licenses/gpl-2.0.html - GNU General Public License, version 2
 * @version     $Id$
 */


/**
 * Abstract page code class. Provides some functions beeing used while creation of code an article
 * page.
 *
 * @package     Plugin_mpContenidoX
 * @subpackage  Frontend_PageCode
 * @author      Murat Purc <murat@purc.de>
 */
abstract class ConMp_Pagecode_Abstract implements ConMp_Pagecode_Interface
{

    protected $_cfg;

    protected $_db;

    protected $_debug = false;

    protected $_containerConf;

    protected $_containerModules;

    protected $_layoutContainer;

    protected $_code;

    protected $_output;


    protected function __construct()
    {
        $this->_cfg = $GLOBALS['cfg'];
        $this->_db  = $GLOBALS['db'];
    }


    public function preDispatch()
    {
    }


    public function postDispatch()
    {
    }

    public function setDebug($debug)
    {
        $this->_debug = $debug;
    }


    public function setContainerConf(array $cc)
    {
        $this->_containerConf = $cc;
    }


    public function setContainerModules(array $cm)
    {
        $this->_containerModules = $cm;
    }


    public function setLayoutContainer(array $lc)
    {
        $this->_layoutContainer = $lc;
    }


    public function setCode($code)
    {
        $this->_code = $code;
    }


    public function processCode()
    {
        // abstract function
        throw new Exception('MP_PageCode_Abstract->processCode() must be inherited by child');
    }

    
    protected function _getLayoutContainerModule($value)
    {
        $sql = "SELECT * FROM " . $this->_cfg['tab']['mod'] . " WHERE idmod='" . (int) $this->_containerModules[$value] . "'";
        $this->_db->query($sql);
        $this->_db->next_record();
        if (is_numeric($this->_containerModules[$value])) {
            $thisModule    = '$cCurrentModule = '. ((int) $this->_containerModules[$value]).';';
            $thisContainer = '$cCurrentContainer = '. ((int) $value).';';
        } else {
            $thisModule    = '';
            $thisContainer = '';
        }

        $mod = (object) $this->_db->Record;
        $mod->outputVirgin = $mod->output;
        $mod->output       = addslashes('<?php ' . $thisModule . $thisContainer . ' ?>' . $mod->output) . "\n";

        return $mod;
    }


    protected function _doContainerConfVarReplacements($module, $value)
    {
		$this->_containerConf[$value] = preg_replace("/(&\$)/", '', $this->_containerConf[$value]);
        $CiCMS_Var   = '$C' . $value . 'CMS_VALUE';
        $module->CiCMS_VALUE = '';
        
        $varstring = array();
        $tmp1 = preg_split("/&/", $this->_containerConf[$value]);
        foreach ($tmp1 as $key1 => $value1) {
            $tmp2 = explode('=', $value1);
            foreach ($tmp2 as $key2 => $value2) {
                $varstring["$tmp2[0]"] = $tmp2[1];
            }
        }

        foreach ($varstring as $key3 => $value3) {
            $tmp = urldecode($value3);
            $tmp = str_replace("\'", "'", $tmp);
            $module->CiCMS_VALUE .= $CiCMS_Var.'['.$key3.']="'.$tmp.'"; ';
            $module->output = str_replace("\$CMS_VALUE[$key3]", $tmp, $module->output);
            $module->output = str_replace("CMS_VALUE[$key3]", $tmp, $module->output);
        }

        $module->output = str_replace('CMS_VALUE', $CiCMS_Var, $module->output);
        $module->output = str_replace("\$" . $CiCMS_Var, $CiCMS_Var, $module->output);

        $module->output = preg_replace('/(CMS_VALUE\[)([0-9]*)(\])/i', '', $module->output);
    }


    protected function _doModuleDebug($module, $value)
    {
        $fedebug = '';
        if ($this->_debug['container_display'] == true) {
            $fedebug .= "Container: CMS_CONTAINER[$value]" . '\\\\n';
        }
        if ($this->_debug['module_display'] == true) {
            $fedebug .= "Modul: " . $module->name . '\\\\n';
        }
        if ($this->_debug['module_timing_summary'] == true || $this->_debug['module_timing'] == true) {
            $fedebug .= 'Eval-Time: $modtime' . $value . '\\\\n';
            $module->output = '<?php $modstart' . $value . ' = getmicrotime(); ?' . '>'
                            . $module->output 
                            . '<?php $modend' . $value . ' = getmicrotime()+0.001; $modtime' . $value . ' = $modend' . $value . ' - $modstart' . $value . '; ?' . '>';
        }

        if ($fedebug != '') {
            $module->output = addslashes('<?php echo \'<img onclick="javascript:showmod' . $value . '();" src="' . $this->_cfg['path']['contenido_fullhtml'] . 'images/but_preview.gif">\'; ?'.'>' . '<br>') . $module->output;
            $module->output = $module->output . addslashes('<?php echo \'<script language="javascript">function showmod' . $value . '(){ window.alert(\\\'\'. "' . addslashes($fedebug) . '".\'\\\');} </script>\'; ?' . '>');
        }

        if ($this->_debug['module_timing_summary'] == true) {
            $module->output .= addslashes(' <?php $cModuleTimes["' . $value . '"] = $modtime' . $value . '; ?>');
            $module->output .= addslashes(' <?php $cModuleNames["' . $value . '"] = "' . addslashes($module->name) . '"; ?>');
        }
    }


    protected function _replaceContainers($module, $value)
    {
        $this->_code = preg_replace("/<container( +)id=\\\\\"$value\\\\\"(.*)>(.*)<\/container>/Uis", "CMS_CONTAINER[$value]", $this->_code);
        $this->_code = preg_replace("/<container( +)id=\\\\\"$value\\\\\"(.*)\/>/i", "CMS_CONTAINER[$value]", $this->_code);
        $this->_code = str_ireplace("CMS_CONTAINER[$value]", "<?php {$module->CiCMS_VALUE} ?>\r\n" . $module->output, $this->_code);
    }


    protected function _check()
    {
        if (!is_array($this->_containerConf)) {
            return false;
        }

        if (!is_array($this->_containerModules)) {
            return false;
        }

        if (!is_array($this->_layoutContainer)) {
            return false;
        }

        if (!isset($this->_code)) {
            return false;
        }
        
        return true;
    }

}