<?php
/**
 * Contenido extension pack (ContenidoX), consists of multiple classes to
 * provide more features for Plugins/Modules.
 *
 * @package     Plugin_mpContenidoX
 * @subpackage  Frontend_PageCode
 * @author      Murat Purc <murat@purc.de>
 * @copyright   Copyright (c) 2008-2010 Murat Purc (http://www.purc.de)
 * @license     http://www.gnu.org/licenses/gpl-2.0.html - GNU General Public License, version 2
 * @version     $Id$
 */


/**
 * Inline page code class. Replaces the module container tags against the module codes.
 * The default way in Contenido CMS.
 *
 * @package     Plugin_mpContenidoX
 * @subpackage  Frontend_PageCode
 * @author      Murat Purc <murat@purc.de>
 */
class ConMp_Pagecode_Container_Inline extends ConMp_Pagecode_Abstract
{

    /**
     * Self instance
     *
     * @var  ConMp_Pagecode_Container_Inline
     */
    private static $_instance;


    /**
     * Prevent public instantiation
     */
    protected function __construct()
    {
        parent::__construct();
    }


    /**
     * Disable cloning
     */
    private function __clone()
    {
    }


    /**
     * Returns self instance
     *
     * @return  ConMp_Pagecode_Container_Inline
     */
    public static function getInstance()
    {
        if (self::$_instance == null) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }


    public function processCode()
    {
        if (!$this->_check()){
            throw new Exception('ConMp_Pagecode_Container_Inline->processCode() Wrong initialization');
        }

		foreach ($this->_layoutContainer as $key => $value) {

            // get layout container module
            $module = $this->_getLayoutContainerModule($value);

			// what the hell is this?
            #$template = $this->_db->f('template');

			// do replacements
            $this->_doContainerConfVarReplacements($module, $value);

			// do some debug related changes
            $this->_doModuleDebug($module, $value);

			// replace module container
            $this->_replaceContainers($module, $value);
		}

        return $this->_code;
    }

}